From d213f1a7a453f548f2dbdb94a1dc4aa684a59e96 Mon Sep 17 00:00:00 2001
From: Nick Steel <nick@nsteel.co.uk>
Date: Mon, 20 Jun 2022 23:42:08 +0100
Subject: [PATCH 08/21] Remove pyspotify: lookup filters compilations and
 various artists

---
 mopidy_spotify/lookup.py | 11 +++++++++++
 tests/test_lookup.py     | 17 ++++++-----------
 2 files changed, 17 insertions(+), 11 deletions(-)

diff --git a/mopidy_spotify/lookup.py b/mopidy_spotify/lookup.py
index dc9e9598..1ec97cf9 100644
--- a/mopidy_spotify/lookup.py
+++ b/mopidy_spotify/lookup.py
@@ -5,6 +5,8 @@
 
 logger = logging.getLogger(__name__)
 
+_VARIOUS_ARTISTS_URI = "spotify:artist:0LyfQWJT6nXafLPZqxe9Of"
+
 
 def lookup(config, web_client, uri):
     if web_client is None or not web_client.logged_in:
@@ -60,6 +62,15 @@ def _lookup_album(config, web_client, link):
 def _lookup_artist(config, web_client, link):
     web_albums = web_client.get_artist_albums(link)
     for web_album in web_albums:
+        is_various_artists = False
+        if web_album.get("album_type", "") == "compilation":
+            continue
+        for artist in web_album.get("artists", []):
+            if artist.get("uri") == _VARIOUS_ARTISTS_URI:
+                is_various_artists = True
+                break
+        if is_various_artists:
+            continue
         yield from translator.web_to_album_tracks(web_album, bitrate=config["bitrate"])
 
 
diff --git a/tests/test_lookup.py b/tests/test_lookup.py
index 65222643..f90296c7 100644
--- a/tests/test_lookup.py
+++ b/tests/test_lookup.py
@@ -116,12 +116,10 @@ def test_lookup_of_artist_ignores_unavailable_albums(
 
 
 def test_lookup_of_artist_uri_ignores_compilations(
-    session_mock, sp_artist_browser_mock, sp_album_browser_mock, provider
+    web_client_mock, web_album_mock, provider
 ):
-    sp_artist_mock = sp_artist_browser_mock.artist
-    session_mock.get_link.return_value = sp_artist_mock.link
-    sp_album_mock = sp_album_browser_mock.album
-    sp_album_mock.type = spotify.AlbumType.COMPILATION
+    web_album_mock["album_type"] = "compilation"
+    web_client_mock.get_artist_albums.return_value = [web_album_mock]
 
     results = provider.lookup("spotify:artist:abba")
 
@@ -129,13 +127,10 @@ def test_lookup_of_artist_uri_ignores_compilations(
 
 
 def test_lookup_of_artist_uri_ignores_various_artists_albums(
-    session_mock, sp_artist_browser_mock, sp_album_browser_mock, provider
+    web_client_mock, web_album_mock, provider
 ):
-    sp_artist_mock = sp_artist_browser_mock.artist
-    session_mock.get_link.return_value = sp_artist_mock.link
-    sp_album_browser_mock.album.artist.link.uri = (
-        "spotify:artist:0LyfQWJT6nXafLPZqxe9Of"
-    )
+    web_album_mock["artists"][0]["uri"] = "spotify:artist:0LyfQWJT6nXafLPZqxe9Of"
+    web_client_mock.get_artist_albums.return_value = [web_album_mock]
 
     results = provider.lookup("spotify:artist:abba")
 

